glibmm: Gio::UnixConnection Class Reference

glibmm 2.32.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions
Gio::UnixConnection Class Reference
Portable Network I/O Functionality

A Unix domain SocketConnection. More...

`#include <giomm/unixconnection.h>`

Inheritance diagram for Gio::UnixConnection:
[legend]

List of all members.

## Public Member Functions
virtual | ~UnixConnection ()
GUnixConnection* | gobj ()
| Provides access to the underlying C GObject.
const GUnixConnection* | gobj () const
| Provides access to the underlying C GObject.
GUnixConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
bool | send_fd (int fd, const Glib::RefPtr< Cancellable >& cancellable)
| Passes a file descriptor to the receiving side of the connection.
int | receive_fd (const Glib::RefPtr< Cancellable >& cancellable)
| Receives a file descriptor from the sending end of the connection.
Glib::RefPtr< Credentials > | receive_credentials (const Glib::RefPtr< Cancellable >& cancellable)
| Receives credentials from the sending end of the connection.
Glib::RefPtr< const Credentials > | receive_credentials (const Glib::RefPtr< Cancellable >& cancellable) const
| Receives credentials from the sending end of the connection.
bool | send_credentials (const Glib::RefPtr< Cancellable >& cancellable)
| Passes the credentials of the current user the receiving side of the connection.
Public Member Functions inherited from Gio::SocketConnection
virtual | ~SocketConnection ()
Glib::RefPtr< Socket > | get_socket ()
| Gets the underlying Socket object of the connection.
Glib::RefPtr< const Socket > | get_socket () const
| Gets the underlying Socket object of the connection.
Glib::RefPtr< SocketAddress > | get_local_address ()
| Try to get the local address of a socket connection.
Glib::RefPtr< const SocketAddress > | get_local_address () const
| Try to get the local address of a socket connection.
Glib::RefPtr< SocketAddress > | get_remote_address ()
| Try to get the remote address of a socket connection.
Glib::RefPtr< const SocketAddress > | get_remote_address () const
| Try to get the remote address of a socket connection.
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Socket > > | property_socket () const
| The underlying GSocket.
Public Member Functions inherited from Gio::IOStream
virtual | ~IOStream ()
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object.
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object.
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it.
bool | close ()
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream.
bool | is_closed () const
| Checks if a stream is closed.
bool | has_pending () const
| Checks if a stream has pending actions.
bool | set_pending ()
| Sets stream to have actions pending.
void | clear_pending ()
| Clears the pending flag on stream.
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
Public Member Functions inherited from sigc::trackable
| trackable (const trackable &src)
trackable & | operator= (const trackable &src)
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | remove_destroy_notify_callback (void *data) const
void | notify_callbacks ()

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixConnection > | wrap (GUnixConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::SocketConnection
Glib::RefPtr < Gio::SocketConnection > | wrap (GSocketConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Static Public Member Functions inherited from Gio::SocketConnection
static Glib::RefPtr < SocketConnection > | create (const Glib::RefPtr< Socket >& socket)
| Creates a SocketConnection subclass of the right type for socket.

## Detailed Description

A Unix domain SocketConnection.

This is the subclass of SocketConnection that is created for UNIX domain sockets.

It contains functions to do some of the unix socket specific functionallity like passing file descriptors.

Since glibmm 2.24:

## Constructor & Destructor Documentation

virtual Gio::UnixConnection::~UnixConnection | ( |  | ) |
| virtual

## Member Function Documentation

GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketConnection.

const GUnixConnection* Gio::UnixConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

Reimplemented from Gio::SocketConnection.

GUnixConnection* Gio::UnixConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Reimplemented from Gio::SocketConnection.

Glib::RefPtr<Credentials> Gio::UnixConnection::receive_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives credentials from the sending end of the connection.

The sending end has to call g_unix_connection_send_credentials() (or similar) for this to work.

As well as reading the credentials this also reads (and discards) a single byte from the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters:

  cancellable | A Cancellable or `0`.

Returns:
  Received credentials on success (free with Glib::object_unref()), `0` if error is set.

Glib::RefPtr<const Credentials> Gio::UnixConnection::receive_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) | const

Receives credentials from the sending end of the connection.

The sending end has to call g_unix_connection_send_credentials() (or similar) for this to work.

As well as reading the credentials this also reads (and discards) a single byte from the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters:

  cancellable | A Cancellable or `0`.

Returns:
  Received credentials on success (free with Glib::object_unref()), `0` if error is set.

int Gio::UnixConnection::receive_fd | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Receives a file descriptor from the sending end of the connection.

The sending end has to call g_unix_connection_send_fd() for this to work.

As well as reading the fd this also reads a single byte from the stream, as this is required for fd passing to work on some implementations.

Since glibmm 2.22:

Parameters:

  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A file descriptor on success, -1 on error.

bool Gio::UnixConnection::send_credentials | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Passes the credentials of the current user the receiving side of the connection.

The receiving end has to call g_unix_connection_receive_credentials() (or similar) to accept the credentials.

As well as sending the credentials this also writes a single NUL byte to the stream, as this is required for credentials passing to work on some implementations.

Other ways to exchange credentials with a foreign peer includes the UnixCredentialsMessage type and g_socket_get_credentials() function.

Since glibmm 2.26:

Parameters:

  cancellable | A Cancellable or `0`.

Returns:
  `true` on success, `false` if error is set.

bool Gio::UnixConnection::send_fd | ( | int | fd,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Passes a file descriptor to the receiving side of the connection.

The receiving end has to call g_unix_connection_receive_fd() to accept the file descriptor.

As well as sending the fd this also writes a single byte to the stream, as this is required for fd passing to work on some implementations.

Since glibmm 2.22:

Parameters:

  fd | A file descriptor.
  cancellable | Optional Cancellable object, `0` to ignore.

Returns:
  A `true` on success, `0` on error.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixConnection > wrap | ( | GUnixConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.